//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace Tecan.Sila2.Interop.Client.UnobservableCommandTest
{
    
    
    /// <summary>
    /// Response type for the Split String After First Character command
    /// </summary>
    [Tecan.Sila2.SilaDisplayNameAttribute("Split String After First Character - Response")]
    public struct SplitStringAfterFirstCharacterResponse
    {
        
        private string _firstCharacter;
        
        private string _remainder;
        
        /// <summary>
        /// Initializes a new instance
        /// </summary>
        public SplitStringAfterFirstCharacterResponse(string firstCharacter, string remainder)
        {
            _firstCharacter = firstCharacter;
            _remainder = remainder;
        }
        
        /// <summary>
        /// The first character, e.g. 'a', or an empty string if the input was empty
        /// </summary>
        [Tecan.Sila2.MaximalLengthAttribute(1)]
        public string FirstCharacter
        {
            get
            {
                return _firstCharacter;
            }
        }
        
        /// <summary>
        /// The remainder, e.g. 'bcde', or an empty string if the input was shorter that two characters
        /// </summary>
        public string Remainder
        {
            get
            {
                return _remainder;
            }
        }
    }
    
    /// <summary>
    /// Feature for testing unobservable commands
    /// </summary>
    [Tecan.Sila2.SilaFeatureAttribute(true, "test")]
    [Tecan.Sila2.SilaIdentifierAttribute("UnobservableCommandTest")]
    [Tecan.Sila2.SilaDisplayNameAttribute("Unobservable Command Test")]
    public partial interface IUnobservableCommandTest
    {
        
        /// <summary>
        /// A command that takes no parameters and returns no responses
        /// </summary>
        void CommandWithoutParametersAndResponses();
        
        /// <summary>
        /// A command that takes one integer parameter and returns its string representation.
        /// </summary>
        /// <param name="integer">An integer, e.g. 12345</param>
        /// <returns>The string representation of the given integer, e.g. '12345'</returns>
        [return: Tecan.Sila2.SilaIdentifierAttribute("StringRepresentation")]
        string ConvertIntegerToString(long integer);
        
        /// <summary>
        /// A command which takes an integer and a string parameter and returns a string with both joined (e.g.
        /// "123abc")
        /// </summary>
        /// <param name="integer">An integer, e.g. 123</param>
        /// <param name="string">A string, e.g. 'abc'</param>
        /// <returns>Both parameters joined as string (e.g. '123abc')</returns>
        [return: Tecan.Sila2.SilaIdentifierAttribute("JoinedParameters")]
        [return: Tecan.Sila2.SilaDisplayNameAttribute("Joined parameters")]
        string JoinIntegerAndString(long integer, string @string);
        
        /// <summary>
        /// A command which splits a given string after its first character. Returns empty parts if the input was
        /// too short.
        /// </summary>
        /// <param name="string">A string, e.g. 'abcde'</param>
        /// <returns>The first character, e.g. 'a', or an empty string if the input was empty, The remainder, e.g. 'bcde', or an empty string if the input was shorter that two characters</returns>
        [return: Tecan.Sila2.InlineStructAttribute()]
        SplitStringAfterFirstCharacterResponse SplitStringAfterFirstCharacter(string @string);
    }
}
